<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/hlo_json/error.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>error.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="ident">thiserror</span>::<span class="ident">Error</span>;

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Error</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">DeriveError</span> {
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Option variable returns unexpected None...&quot;</span>)]</span>
    <span class="ident">OptionNone</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Meta key not found...&quot;</span>)]</span>
    <span class="ident">MetaKeyNotFound</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Meta value not found...&quot;</span>)]</span>
    <span class="ident">MetaValueNotFound</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;derivation not yet implemented&quot;</span>)]</span>
    <span class="ident">DerivationUnimplemented</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;HLO AST not present in struct, cannot perform cache&quot;</span>)]</span>
    <span class="ident">ASTNotPresent</span>(),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Instruction cache miss even after a full AOT generation&quot;</span>)]</span>
    <span class="ident">InstNotInCache</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Caching not run before trying to get the result&quot;</span>)]</span>
    <span class="ident">CacheNotAvailable</span>(),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;unknown data store error&quot;</span>)]</span>
    <span class="ident">Unknown</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Error</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">PropagationError</span> {
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Option variable returns unexpected None...&quot;</span>)]</span>
    <span class="ident">OptionNone</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Visiting an already visited node, with incompatible params&quot;</span>)]</span>
    <span class="ident">AlreadyVisitedIncompatible</span>(<span class="ident">String</span>),
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;unknown propagation error&quot;</span>)]</span>
    <span class="ident">Unknown</span>,
}

<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Error</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ASTError</span> {
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;AST Function Positional Caching called twice!&quot;</span>)]</span>
    <span class="ident">CacheFuncTwice</span>,
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;AST Instruction Positional Caching called twice!&quot;</span>)]</span>
    <span class="ident">CacheInstTwice</span>,
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;AST Variable Positional Caching called twice!&quot;</span>)]</span>
    <span class="ident">CacheVarPosTwice</span>,
    <span class="attribute">#[<span class="ident">error</span>(<span class="string">&quot;Unknown AST Operation Error...&quot;</span>)]</span>
    <span class="ident">Unknown</span>,
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "HPGO";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>